//  "⠪᪨ "

#include "calc.h"
#include <stack>

// ७ ६ - ⥪  ⥪饥 ࠢ
stack<char> Stack;
const char *rule;


// ⠭, 騥 ࠬ⨪

// ନ  ନ
const char terminals[]    = "N+-*/();$";
const char nonterminals[] = "SEeTtF";

// ࠢ 뢮 ( ਡ⠬)
const char *R[]      = {"",                 //0 - not a rule
                        "S>E@P;S",          //1
                        "S>",               //2
                        "E>Te",             //3
                        "e>+T@+e",          //4
                        "e>-T@-e",          //5
                        "e>",               //6
                        "T>Ft",             //7
                        "t>*F@*t",          //8
                        "t>/F@/t",          //9
                        "t>",               //10
                        "F>N@N",            //11
                        "F>(E)"             //12
                        }; 


//  ࠧ  LL(1) ࠬ⨪
const int M[6][9]  = 
//         N  +  -  *  /  (  )  ;  $
/* S */ {{ 1, 0, 0, 0, 0, 1, 0, 0, 2},
/* E */  { 3, 0, 0, 0, 0, 3, 0, 0, 0},
/* e */  { 0, 4, 5, 0, 0, 0, 6, 6, 0},
/* T */  { 7, 0, 0, 0, 0, 7, 0, 0, 0},
/* t */  { 0,10,10, 8, 9, 0,10,10, 0},
/* F */  {11, 0, 0, 0, 0,12, 0, 0, 0}};

// 室 ६

int x201()
{
    int res = (Stack.top() == '@');
    log_input("x201 -  設 ⥪ - ", res);
    return res;
}

int x202()
{
    int res = (strchr(terminals, Stack.top()) != NULL);
    log_input("x202 -  設 ⥪ - ନ", res);
    return res;
}

int x203()
{
    int res = (strchr(nonterminals, Stack.top()) != NULL);
    log_input("x203 -  設 ⥪ - ନ", res);
    return res;
}

int x204()
{
    int res = (Stack.top() == LexemeType);
    log_input("x204 - ନ  設 ⥪ ᮢ  ⥪饩 ᥬ", res);
    return res;
}

int x205()
{
    int res = (LexemeType == '$') && (Stack.top() == '$');
    log_input("x205 -  ᥬ - $  設 c⥪ - $", res);
    return res;
}

int x206()
{
    int res = (LexemeType == 'E');
    log_input("x206 -  ᥬ - 訡", res);
    return res;
}

int x207()
{
    int res = (strcmp(rule, R[0]) != 0);
    log_input("x207 - 饥 ࠢ 뢮  ( 訡)", res);
    return res;
}

// 室 ⢨

void z200()
{
    log_output("z200 - 樠஢ ⥪ (   $S)");
    Stack.push('$');
    Stack.push(nonterminals[0]); 
}

void z201()
{
    log_output("z201 -    ⥪  ᯮ");
    Stack.pop();
    Command = Stack.top();
    Stack.pop();
}

void z202()
{
    log_output("z202 -  ନ  ⥪");
    Stack.pop();
}

void z203()
{
    log_output("z203 - । ࠢ 뢮");
    int  t = strchr(terminals, LexemeType) - terminals;
    int nt = strchr(nonterminals, Stack.top()) - nonterminals;

    int rulenum = M[nt][t];

    rule = R[rulenum];

    Stack.pop();
}

void z204()
{
    log_output("z204 -   ⥪ ࠢ 뢮");
    for (const char *c = rule + strlen(rule) - 1; *c != '>'; c--)
        Stack.push(*c);
}

void z205()
{
    log_output("z205 - 뢥 ᮮ饭  訡");
    cout << "訡  ࠦ." << endl;
}

void z301()
{
    log_output("z301 - ᯮ  ⥪ 設");
    StackMachine();
}

// ⮬ ᨭ⠪᪮ 

void A2()
{
    int y2 = 0;

    log_automata_started("A2", y2);
    do {
        switch (y2)
        {
            case 0:
            {
                log_state_changed("A2", y2, "砫 ࠡ");
                                z200(); A1();                   y2 = 1;
            }
            break;
            case 1:
            {
                log_state_changed("A2", y2, " ⥪");
                if (x206()) {                                   y2 = 4; }
                else
                if (x201()) {   z201(); z301();                         }
                else 
                if (x202()) {                                   y2 = 2; }
                else 
                if (x203()) {   z203();                         y2 = 3; }
            }
            break;
            case 2:
            {
                log_state_changed("A2", y2, "ନ");                
                if (x205()) {                                   y2 = 0; }
                else
                if (x204())
                            {   z202(); A1();                   y2 = 1; }
                else 
                            {                                   y2 = 4; }
            }
            break;
            case 3:
            {
                log_state_changed("A2", y2, "ନ");              
                if (x207()) {   z204();                         y2 = 1; }
                else
                            {                                   y2 = 4; }
            }
            break;
            case 4:
            {
                log_state_changed("A2", y2, "訡");              
                                z205();                         y2 = 0;
            }
            break;
        }
    } while (y2);

    log_automata_ended("A2", y2);
}
